<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-row dense>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-pick-list
              ref="customerId"
              v-model="obj.customerId"
              :aya-type="ayaTypes().Customer"
              show-edit-icon
              :include-inactive="true"
              readonly
              :label="$ay.t('Customer')"
              data-cy="customerId"
            ></gz-pick-list>
          </v-col>
          <v-col
            v-if="form().showMe(this, 'Priority')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-select
              ref="priority"
              v-model="obj.priority"
              dense
              :color="priorityColor()"
              :item-color="priorityColor()"
              readonly
              :items="selectLists.priorities"
              item-text="name"
              item-value="id"
              :label="$ay.t('CustomerServiceRequestPriority')"
              data-cy="priority"
              append-icon=""
            >
              <template v-slot:prepend
                ><v-icon :color="priorityColor()">
                  $ayiCircle
                </v-icon>
              </template></v-select
            >
          </v-col>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-date-picker
              ref="dateRequested"
              v-model="obj.dateRequested"
              :label="$ay.t('Created')"
              readonly
              data-cy="dateRequested"
            ></gz-date-picker>
          </v-col>
          <v-col
            v-if="form().showMe(this, 'Status')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-select
              ref="status"
              v-model="obj.status"
              dense
              :items="selectLists.status"
              item-text="name"
              item-value="id"
              readonly
              :label="$ay.t('CustomerServiceRequestStatus')"
              data-cy="status"
              append-icon=""
            ></v-select>
          </v-col>

          <v-col
            v-if="obj.workOrderItemId != null"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-btn text @click="openWO()">
              <v-icon>$ayiTools</v-icon>
              <span class="text-h6 accent--text" @click="openWO()"
                >{{ $ay.t("WorkOrder") }} {{ obj.workOrderItemViz }}</span
              ></v-btn
            >
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="name"
              v-model="obj.name"
              dense
              readonly
              :label="$ay.t('CustomerServiceRequestTitle')"
              :rules="[form().required(this, 'name')]"
              :error-messages="form().serverErrors(this, 'name')"
              data-cy="name"
              @input="fieldValueChanged('name')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'CustomerReferenceNumber')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="customerReferenceNumber"
              v-model="obj.customerReferenceNumber"
              dense
              readonly
              :label="$ay.t('CustomerServiceRequestCustomerReferenceNumber')"
              data-cy="customerReferenceNumber"
              :error-messages="
                form().serverErrors(this, 'customerReferenceNumber')
              "
              @input="fieldValueChanged('customerReferenceNumber')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RequestedByUserId')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="requestedByUserId"
              v-model="obj.requestedByUserId"
              :aya-type="ayaTypes().User"
              :variant="'outside'"
              show-edit-icon
              readonly
              :label="$ay.t('CustomerServiceRequestRequestedBy')"
              data-cy="requestedByUserId"
              :error-messages="form().serverErrors(this, 'requestedByUserId')"
              @input="fieldValueChanged('requestedByUserId')"
            ></gz-pick-list>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'UnitId')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="unitId"
              v-model="obj.unitId"
              :aya-type="ayaTypes().Unit"
              :variant="'customerid:' + obj.customerId"
              show-edit-icon
              readonly
              :label="$ay.t('CustomerServiceRequestItemUnitID')"
              data-cy="unitId"
              :error-messages="form().serverErrors(this, 'unitId')"
              @input="fieldValueChanged('unitId')"
            ></gz-pick-list>
          </v-col>

          <!--   --------------------------------- -->
          <v-col v-if="form().showMe(this, 'Notes')" cols="12">
            <v-textarea
              ref="notes"
              v-model="obj.notes"
              dense
              readonly
              :label="$ay.t('CustomerServiceRequestDetails')"
              :error-messages="form().serverErrors(this, 'notes')"
              data-cy="notes"
              auto-grow
              @input="fieldValueChanged('notes')"
            ></v-textarea>
          </v-col>

          <v-col v-if="form().showMe(this, 'Tags')" cols="12">
            <gz-tag-picker
              ref="tags"
              v-model="obj.tags"
              :readonly="formState.readOnly"
              data-cy="tags"
              :error-messages="form().serverErrors(this, 'tags')"
              @input="fieldValueChanged('tags')"
            ></gz-tag-picker>
          </v-col>

          <v-col cols="12">
            <gz-custom-fields
              ref="customFields"
              v-model="obj.customFields"
              :form-key="formCustomTemplateKey"
              :readonly="formState.readOnly"
              :parent-v-m="this"
              data-cy="customFields"
              :error-messages="form().serverErrors(this, 'customFields')"
              @input="fieldValueChanged('customFields')"
            ></gz-custom-fields>
          </v-col>

          <v-col v-if="form().showMe(this, 'Wiki')" cols="12">
            <gz-wiki
              ref="wiki"
              v-model="obj.wiki"
              :aya-type="ayaType"
              :aya-id="obj.id"
              :readonly="formState.readOnly"
              @input="fieldValueChanged('wiki')"
            ></gz-wiki
          ></v-col>

          <v-col v-if="form().showMe(this, 'Attachments') && obj.id" cols="12">
            <gz-attachments
              :readonly="formState.readOnly"
              :aya-type="ayaType"
              :aya-id="obj.id"
            ></gz-attachments
          ></v-col>
        </v-row>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "csr-edit";
const API_BASE_URL = "csr/";
const FORM_CUSTOM_TEMPLATE_KEY = "CustomerServiceRequest";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      selectedWOId: 0,
      woSelectorDialog: false,
      selectLists: {
        status: [],
        priorities: []
      },
      obj: {
        id: 0,
        concurrency: 0,
        name: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        dateRequested: window.$gz.locale.nowUTC8601String(),
        customerId: null,
        unitId: null,
        workOrderItemId: null,
        requestedByUserId: null,
        customerReferenceNumber: null,
        status: 0,
        priority: 0
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.CustomerServiceRequest
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":reject");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":reject");
        }
        if (!val.dirty && val.valid) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":acceptnew"
          );
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":acceptnew"
          );
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(
        window.$gz.type.CustomerServiceRequest
      );
      vm.formState.readOnly = !vm.rights.change || vm.obj.status != 0;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
          window.$gz.form.setFormState({
            vm: vm,
            loading: false
          });
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
      window.$gz.form.setFormState({
        vm: vm,
        dirty: false,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    openWO: function() {
      window.$gz.eventBus.$emit("openobject", {
        type: window.$gz.type.WorkOrderItem,
        id: this.obj.workOrderItemId
      });
    },
    priorityColor: function() {
      switch (this.obj.priority) {
        case 1: //asap
          return "warning";
        case 2: //emergency
          return "error";
        default:
          return "success";
      }
    },
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
          vm.formState.readOnly = !vm.rights.change || vm.obj.status != 0;
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "csr-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }

          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    async reject() {
      const vm = this;
      if (vm.obj.status != 0 || vm.$route.params.recordid == 0) {
        return;
      }
      //change status to rejected and save
      vm.obj.status = 2; //declined=2, accepted=1
      try {
        await this.submit();
        vm.$router.go(-1);
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async accept() {
      //generate work order from this csr
      //flag this csr as accepted
      const vm = this;
      if (vm.$route.params.recordid == 0) {
        return;
      }
      //create new workorder for this csr
      //navigate to the new workorder so it can be edited and or saved
      //workorder is responsible for flagging as fromcsr so that server can update the csr when it sees the wo is new and the fromcsrid is set
      const w = {
        id: 0,
        concurrency: 0,
        serial: 0,
        notes: this.obj.name,
        wiki: null,
        customFields: "{}",
        tags: [],
        customerId: this.obj.customerId,
        projectId: null,
        contractId: null,
        internalReferenceNumber: null,
        customerReferenceNumber: this.obj.customerReferenceNumber,
        customerContactName: this.obj.requestedByUserViz,
        fromQuoteId: null,
        fromPMId: null,
        serviceDate: null,
        completeByDate: null,
        durationToCompleted: "00:00:00",
        invoiceNumber: null,
        onsite: true,
        customerSignature: null,
        customerSignatureName: null,
        customerSignatureCaptured: null,
        techSignature: null,
        techSignatureName: null,
        techSignatureCaptured: null,
        postAddress: null,
        postCity: null,
        postRegion: null,
        postCountry: null,
        postCode: null,
        address: null,
        city: null,
        region: null,
        country: null,
        addressPostal: null,
        latitude: null,
        longitude: null,
        items: [],
        states: [],
        isDirty: true,
        isLockedAtServer: false,
        alertViz: null
      };
      const wi = {
        id: 0,
        concurrency: 0,
        fromCSRId: this.obj.id,
        keepCSR: true, //this indicates to svc-workorder NOT to "wash" away the csrId
        notes: this.obj.name,
        wiki: null,
        customFields: "{}",
        tags: [],
        workOrderId: 0,
        techNotes: this.obj.notes,
        workOrderItemStatusId: null,
        workOrderItemPriorityId: null,
        requestDate: this.obj.dateRequested,
        warrantyService: false,
        sequence: 1,
        isDirty: true,
        expenses: [],
        labors: [],
        loans: [],
        parts: [],
        partRequests: [],
        scheduledUsers: [],
        tasks: [],
        travels: [],
        units: [],
        outsideServices: []
      };
      if (this.obj.unitId != null) {
        wi.units.push({
          id: 0,
          concurrency: 0,
          wiki: null,
          customFields: "{}",
          tags: [],
          notes: null,
          unitId: this.obj.unitId,
          isDirty: true,
          workOrderItemId: 0,
          unitViz: null,
          warrantyViz: null
        });
      }
      w.items.push(wi);
      this.$router.push({
        name: "workorder-edit",
        params: {
          recordid: 0,
          obj: w
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "reject":
        m.vm.reject();
        break;
      case "acceptnew":
        m.vm.accept();
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.CustomerServiceRequest,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly || vm.obj.status != 0,
    icon: "$ayiConciergeBell",
    title: "CustomerServiceRequest",
    helpUrl: "svc-csr",
    formData: {
      ayaType: window.$gz.type.CustomerServiceRequest,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName: vm.obj.name
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  if (
    vm.rights.delete &&
    vm.$route.params.recordid != 0 &&
    !vm.formState.readOnly
  ) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }
  menuOptions.menuItems.push({ divider: true, inset: false });

  if (vm.rights.change) {
    if (vm.obj.status != 1) {
      //if not already accepted, this allows to accept even if rejected earlier
      menuOptions.menuItems.push({
        title: "CustomerServiceRequestAcceptToNew",
        icon: null,
        key: FORM_KEY + ":acceptnew",
        vm: vm
      });
    }
    if (vm.obj.status == 0) {
      menuOptions.menuItems.push({
        title: "CustomerServiceRequestReject",
        icon: null,
        key: FORM_KEY + ":reject",
        vm: vm
      });
    }
    menuOptions.menuItems.push({ divider: true, inset: false });
  }
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}
let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
  await populateSelectionLists(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "CustomerServiceRequest",
    "CustomerServiceRequestAcceptToNew",
    "CustomerServiceRequestReject",
    "CustomerServiceRequestTitle",
    "CustomerServiceRequestDetails",
    "Created",
    "Customer",
    "CustomerServiceRequestItemUnitID",
    "WorkOrder",
    "CustomerServiceRequestRequestedBy",
    "CustomerServiceRequestCustomerReferenceNumber",
    "CustomerServiceRequestStatus",
    "CustomerServiceRequestPriority",
    "CustomerServiceRequestCustom1",
    "CustomerServiceRequestCustom2",
    "CustomerServiceRequestCustom3",
    "CustomerServiceRequestCustom4",
    "CustomerServiceRequestCustom5",
    "CustomerServiceRequestCustom6",
    "CustomerServiceRequestCustom7",
    "CustomerServiceRequestCustom8",
    "CustomerServiceRequestCustom9",
    "CustomerServiceRequestCustom10",
    "CustomerServiceRequestCustom11",
    "CustomerServiceRequestCustom12",
    "CustomerServiceRequestCustom13",
    "CustomerServiceRequestCustom14",
    "CustomerServiceRequestCustom15",
    "CustomerServiceRequestCustom16"
  ]);
}

//////////////////////
//
//
async function populateSelectionLists(vm) {
  await window.$gz.enums.fetchEnumList("CustomerServiceRequestStatus");
  vm.selectLists.status = window.$gz.enums.getSelectionList(
    "CustomerServiceRequestStatus"
  );
  await window.$gz.enums.fetchEnumList("CustomerServiceRequestPriority");
  vm.selectLists.priorities = window.$gz.enums.getSelectionList(
    "CustomerServiceRequestPriority"
  );
}
</script>
